#define kdevice L"\\Device\\mykdv"
#define udevice L"\\DosDevices\\myudv"

#include<ntddk.h>
DRIVER_UNLOAD mydriverunload;
__drv_dispatchType(IRP_MJ_CREATE)
DRIVER_DISPATCH creat;
__drv_dispatchType(IRP_MJ_CLOSE)
DRIVER_DISPATCH clos;
__drv_dispatchType(IRP_MJ_WRITE)
DRIVER_DISPATCH getmsg;
/*__drv_dispatchType(IRP_MJ_DEVICE_CONTROL)
DRIVER_DISPATCH cont;*/
#pragma alloc_text(page,getmsg)
NTSTATUS DriverEntry(PDRIVER_OBJECT DRVROB, PUNICODE_STRING RGSPATH)
{
   NTSTATUS create_status;
   UNICODE_STRING  name,device;
   PDEVICE_OBJECT  device_object=NULL;
   RtlInitUnicodeString(&device,kdevice);
   create_status=IoCreateDevice(
	   DRVROB,0,                       
	   &device,                      //20
	   FILE_DEVICE_UNKNOWN,            // Device type
       FILE_DEVICE_SECURE_OPEN,     // Device characteristics
       FALSE,
	   &device_object	   
	   );
       DbgPrint("hello (kernel mode)");
	   device_object->Flags |=DO_BUFFERED_IO;
	   
   	   if(!NT_SUCCESS(create_status))
	   {
	       DbgPrint("not possible!!!! ");
		   return create_status;
	   }
	   RtlInitUnicodeString(&name,udevice);
	   create_status=IoCreateSymbolicLink(&name,&device);
	   if(!NT_SUCCESS(create_status))
	   {
	     DbgPrint("not possible!");
		 IoDeleteDevice(device_object);	   
	   }
       DRVROB->DriverUnload=mydriverunload;
	   DRVROB->MajorFunction[IRP_MJ_CREATE]=creat;     //40
	   DRVROB->MajorFunction[IRP_MJ_CLOSE]=clos;
	   //DRVROB->MajorFunction[IRP_MJ_DEVICE_CONTROL]=cont;  // in ro nanveshtam hanooz
	   DRVROB->MajorFunction[IRP_MJ_WRITE]=getmsg;


   return STATUS_SUCCESS;  
}
VOID mydriverunload(PDRIVER_OBJECT d)
{

    PDEVICE_OBJECT A=d->DeviceObject;
	UNICODE_STRING name;
	RtlInitUnicodeString(&name,udevice);
	IoDeleteSymbolicLink(&name);
	if(A!=NULL)
	{
	  DbgPrint("unload!");
	  IoDeleteDevice(A);
	}
}
///////////////////////////////
NTSTATUS creat(PDEVICE_OBJECT ob1,PIRP irp)      //60
{
	PAGED_CODE();

    irp->IoStatus.Status=STATUS_SUCCESS;
    irp->IoStatus.Information=0;
	IoCompleteRequest(irp,IO_NO_INCREMENT);
	DbgPrint("CREATE\t");
	return STATUS_SUCCESS;
}
NTSTATUS clos(PDEVICE_OBJECT ob1,PIRP irp)
{
	PAGED_CODE();

  irp->IoStatus.Status=STATUS_SUCCESS;
  irp->IoStatus.Information=0;
  IoCompleteRequest(irp,IO_NO_INCREMENT);
  DbgPrint("Close");
  return STATUS_SUCCESS;
}
NTSTATUS getmsg(PDEVICE_OBJECT ob1,PIRP irp)
{
   PIO_STACK_LOCATION myirp=NULL;
   PCHAR str;
   myirp=IoGetCurrentIrpStackLocation(irp);   
   if(myirp)
   {
      str=(PCHAR)irp->AssociatedIrp.SystemBuffer;
      DbgPrint(str);
   }
   return STATUS_SUCCESS;
}

